package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;

public class AtualizarDataReferenciaCustosPage extends PageBase {
    By clicaMenu = By.xpath("//*[@type = 'button']");
    By Inicio = By.xpath("//*[@class = 'navbar-brand zh-header-title has-header-info']");
    By clicaPlanejamento = By.xpath("//*[@class = 'menu-link']//*[contains(text(),'Planejamento')]");
    By clicaCardapio = By.xpath("/html/body/span/section/section/div[2]/section[1]/div/aside/div[2]/nav/ul/li[1]/ul/li[2]/ul/li[1]/span/span[3]");
    By clicaAtualizarData = By.xpath("//span[text() = 'Atualizar Data de Referência para Custos']");
    By confirmaAcessoTela = By.xpath("//div[@class = 'navbar-header']//div[@class = 'navbar-brand zh-header-title has-header-info']");
    By buscaAgrupamento = By.xpath("//div[@id = 'NMGRUPFILI']//span[@zh-icon='no-border search']");
    By selecionaAgrupamento = By.xpath("//span[text() = '0000000002']");
    By chebBoxTodasUnidades = By.xpath("//label[@for = 'zh-checkbox-CHECK_NMFILIAL']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By campoUnidade = By.xpath("//div[@name = 'NMFILIAL']");
    By lupaFiltro = By.xpath("//*[@id='popup']//span[@class = 'action-icon search-action-icon zh-icon zh-icon-search zh-icon-no-border zh-icon-color-white']");
    By insereInformacaoBusca = By.xpath("//input[@class = 'mousetrap zh-input-search-floating ng-pristine ng-valid ng-touched']");
    By selecionaUnidade = By.xpath("//div[@class = 'body-content']//div[@class = 'td grid-checkbox-column zh-side-column fixed zh-ripple-effect']");
    By btnOk = By.xpath("//div[@id = 'footer']//span[text() = 'Ok']");
    By checkBoxTodosServicos = By.xpath("//label[@for = 'zh-checkbox-CHECK_NMSERVICO']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By campoServicos = By.xpath("//div[@class = 'zh-select-multiple mousetrap zh-field-NMSERVICO zh-text-align-left']");
    By selecionaServico = By.xpath("//div[@class = 'body-content']//div[@class = 'td grid-checkbox-column zh-side-column fixed zh-ripple-effect']");
    By limpaMes = By.xpath("//div[@class = 'zh-select-multiple zh-field-MES zh-text-align-left']//span[@zh-icon='no-border close-x']");
    By limpaPeriodo = By.xpath("//*[@id='MES']/span[2]");
    By campoPeriodo = By.xpath("//div[@class = 'zh-select-multiple zh-field-MES zh-text-align-left ng-touched']");
    By selecionaMes = By.xpath("//div[@class = 'month']//div[text() = 'Fev']");
    By buscaTipoCusto = By.xpath("//div[@class = 'zh-select-multiple zh-select-autocomplete mousetrap zh-field-NMTIPOCUSTO zh-text-align-left']//span[@zh-icon='no-border search']");
    By selecionaTipoCusto = By.xpath("//*[@id='popup']/span/section/section/section/div/div[1]/ul/li[2]/div/div");
    By limpaDataReferencia = By.xpath("//div[@class = 'zh-select-date zh-field-DTREF']//span[@zh-icon='no-border close-x']");
    By insereDataReferencia = By.xpath("//input[@class = 'input-text zh-calendar-input mousetrap ng-pristine ng-valid ng-touched']");
    By botaoCalendario = By.xpath("//span[@zh-icon='no-border calendar']");
    By calendarioDataReferencia = By.xpath("//div[@class = 'zh-select-date zh-field-DTREF']//span[@zh-icon='no-border calendar']");
    By diaDataReferencia = By.xpath("//div[@class = 'day']//div[text() = '17']");
    By diaDataReferenciaAtual = By.xpath("//div[@class = 'day today']");
    By btnConfirmar = By.xpath("//span[text() = 'Confirmar']");
    By confirmaMensagem = By.xpath("//button[@data-ng-repeat='button in buttons']//span[text() = 'Sim']");
    By periodoAnterior = By.xpath("//div[@class = 'arrow-left zh-icon zh-icon-previous zh-icon-no-border']");
    By mesDezembro = By.xpath("//div[@class = 'month']//div[text() = 'Dez']");
    By botaoOk = By.xpath("//footer[@class = 'zh-footer-alert']//button[@class = 'zh-alert-button']");

    public void acessaTelaAtualizaDataReferencia(){
        waitForVisibilityOfElementLocated(Inicio);
        tempo();
        click(clicaMenu);
        tempo();
        click(clicaPlanejamento);
        tempo();
        click(clicaCardapio);
        tempo();
        click(clicaAtualizarData);
        tempo();
        waitForVisibilityOfElementLocated(confirmaAcessoTela);
        tempo();
    }

    public void realizaFiltro(){
        click(buscaAgrupamento);
        tempo();
        click(selecionaAgrupamento);
        tempo();
        click(chebBoxTodasUnidades);
        click(campoUnidade);
        tempo();
        click(lupaFiltro);
        click(lupaFiltro);
        tempo();
        click(insereInformacaoBusca);
        sendKeys(insereInformacaoBusca,"0002");
        tempo();
        click(selecionaUnidade);
        click(btnOk);
        tempo();
        click(checkBoxTodosServicos);
        click(campoServicos);
        tempo();
        click(lupaFiltro);
        click(lupaFiltro);
        tempo();
        click(insereInformacaoBusca);
        sendKeys(insereInformacaoBusca,"00002");
        tempo();
        click(selecionaServico);
        click(btnOk);
        tempo();
        click(limpaMes);
        click(botaoCalendario);
        tempo();
        click(selecionaMes);
        tempo();
        click(buscaTipoCusto);
        tempo();
        click(lupaFiltro);
        click(lupaFiltro);
        tempo();
        click(insereInformacaoBusca);
        sendKeys(insereInformacaoBusca,"Custo Médio Bruto da Época");
        tempo();
        click(selecionaTipoCusto);
        tempo();
        click(limpaDataReferencia);
        click(calendarioDataReferencia);
        tempo();
        click(diaDataReferencia);
        tempo();
        click(btnConfirmar);
        tempo();
        click(confirmaMensagem);
        tempo();
        tempo();
        tempo();
        click(botaoOk);
        click(limpaDataReferencia);
        click(calendarioDataReferencia);
        tempo();
        click(diaDataReferenciaAtual);
        click(btnConfirmar);
        tempo();
        click(confirmaMensagem);
        tempo();
        tempo();
        tempo();
        click(botaoOk);
    }

    public void filtroTodos(){
    click(chebBoxTodasUnidades);
    tempo();
    click(limpaPeriodo);
    tempo();
    click(botaoCalendario);
    tempo();
    click(periodoAnterior);
    click(mesDezembro);
    click(btnConfirmar);
    tempo();
    click(botaoOk);
    tempo();
    click(limpaPeriodo);
    tempo();
    click(botaoCalendario);
    tempo();
    click(selecionaMes);
    tempo();
    click(btnConfirmar);
    click(confirmaMensagem);
    tempo();
    tempo();
    tempo();
    click(botaoOk);
    tempo();

    }

}
